package corona.logik;

import java.awt.Graphics;

public class Simulation implements HasSize, Moveable, Paintable{
	Proband[] ps;
	Vertex size = new Vertex(1000, 700);	
	
	public Simulation() {
		ps = new Proband[1000];
		for (int i = 0; i < ps.length; i++) {
			ps[i] = new Proband(new Vertex(Math.random()*getWidth(), Math.random()*getHeight()));
			ps[i].velocity = new Vertex(Math.random()*3-1.5, Math.random()*3-1.5);
			if (i<10)ps[i].status=InfektionsStatus.infiziert;
		}
	}
	
	@Override
	public void paintMeTo(Graphics g) {
		for (Proband proband : ps) {
			proband.paintMeTo(g);	
		}
	}

	@Override
	public void move() {
		doChecks();
		for (Proband proband1 : ps) {
			proband1.move();
		}
		
	}

	private void doChecks() {
		for (Proband proband : ps) {
			if (proband.getX()<=0) {
				proband.velocity.x = Math.abs(proband.velocity.x);
			}
			if (proband.getY()<=0) {
				proband.velocity.y = Math.abs(proband.velocity.y);
			}
			if (proband.getX()+proband.getWidth()>=getWidth()) {
				proband.velocity.x = -Math.abs(proband.velocity.x);
			}
			if (proband.getY()+proband.getHeight()>=getHeight()) {
				proband.velocity.y = -Math.abs(proband.velocity.y);
			}
			for (Proband proband2 : ps) {
				if (proband.touches(proband2)&&proband.status==InfektionsStatus.infiziert
					&&	proband2.status==InfektionsStatus.gesund) {
					proband2.status=InfektionsStatus.infiziert;
				}
			}
			
			if (proband.status==InfektionsStatus.infiziert) {
				proband.infectedSince++;
			}
			if (proband.infectedSince>300) {
				proband.status=InfektionsStatus.genesen;
				if (Math.random()<0.02) proband.status=InfektionsStatus.tot;
				proband.infectedSince=0;
			}

		}
		
	}

	@Override
	public Vertex getSize() {
		return size;
	}
}
